## kodi 21.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
if(WIN32)
  # Version 3.20 is required for multi-config generator expressions to work
  cmake_minimum_required(VERSION 3.20)
endif()
project(kodi LANGUAGES CXX C ASM)

if(POLICY CMP0069)
  set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
  cmake_policy(SET CMP0069 NEW)
endif()

if(POLICY CMP0135)
  set(CMAKE_POLICY_DEFAULT_CMP0135 NEW)
  cmake_policy(SET CMP0135 NEW)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules/buildtools)
if(DEPENDS_DIR)
  list(APPEND CMAKE_PREFIX_PATH ${DEPENDS_DIR})
endif()

# Variable to indicate if the project is targeting a Multi Config Generator (VS/Xcode primarily)
get_property(_multiconfig_generator GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_multiconfig_generator)
  # Target to encompass an optional way to build all internal dependencies
  # Must set EXCLUDE_FROM_ALL property so the ALL target doesnt include this, and therefore
  # build all internal dependencies
  add_custom_target(build_internal_depends)
  set_target_properties(build_internal_depends PROPERTIES EXCLUDE_FROM_ALL TRUE)
endif()

# Set CORE_BUILD_DIR
set(CORE_BUILD_DIR build)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# set KODI_MIRROR to the default if not already set
if(NOT DEFINED KODI_MIRROR)
  set(KODI_MIRROR "http://mirrors.kodi.tv")
endif()

message(STATUS "Mirror download location: ${KODI_MIRROR}")
message(STATUS "Source directory: ${CMAKE_SOURCE_DIR}")
message(STATUS "Build directory: ${CMAKE_BINARY_DIR}")
if(CMAKE_BINARY_DIR STREQUAL CMAKE_SOURCE_DIR)
  message(WARNING "In-source build detected. It is recommended to build out-of-source.")
endif()

# Hide messages from Check*.cmake (e.g. CheckCSourceCompiles)
if(NOT VERBOSE)
  set(CMAKE_REQUIRED_QUIET ON)
endif()

# Includes
include(cmake/modules/extra/ECMEnableSanitizers.cmake)
include(cmake/scripts/common/GeneratorSetup.cmake)
include(cmake/scripts/common/AddOptions.cmake)
include(cmake/scripts/common/Platform.cmake)
include(cmake/scripts/common/ArchSetup.cmake)
include(cmake/scripts/common/Macros.cmake)
include(cmake/scripts/common/ProjectMacros.cmake)
core_find_versions()
include(cmake/scripts/common/PathSetup.cmake)
include(cmake/scripts/common/CompilerSettings.cmake)
include(ExternalProject)
include(CMakeDependentOption)
include(cmake/scripts/common/DependencyOptions.cmake)

# general
option(VERBOSE            "Enable verbose output?" OFF)
option(ENABLE_CLANGTIDY   "Enable clang-tidy support?" OFF)
option(ENABLE_CPPCHECK    "Enable cppcheck support?" OFF)
option(ENABLE_DVDCSS      "Enable libdvdcss support?" ON)
option(ENABLE_INCLUDEWHATYOUUSE "Enable include-what-you-use support?" OFF)
option(ENABLE_UPNP        "Enable UPnP support?" ON)
option(ENABLE_AIRTUNES    "Enable AirTunes support?" ON)
option(ENABLE_OPTICAL     "Enable optical support?" ON)
option(ENABLE_PYTHON      "Enable python support?" ON)
option(ENABLE_TESTING     "Enable testing support?" ON)

# Internal Depends - supported on all platforms

# These are required enabled for all CI platforms, and recommended for all builds
option(ENABLE_INTERNAL_CROSSGUID "Enable internal crossguid?" ON)

# use ffmpeg from depends or system
option(ENABLE_INTERNAL_FFMPEG "Enable internal ffmpeg?" OFF)

# These are built for all platforms not using system libs or disabled by user
dependent_option(ENABLE_INTERNAL_CEC "Enable internal libcec?")
dependent_option(ENABLE_INTERNAL_FLATBUFFERS "Enable internal flatbuffers?")
dependent_option(ENABLE_INTERNAL_FMT "Enable internal fmt?")
dependent_option(ENABLE_INTERNAL_NFS "Enable internal libnfs?")
dependent_option(ENABLE_INTERNAL_PCRE "Enable internal pcre?")
dependent_option(ENABLE_INTERNAL_RapidJSON "Enable internal rapidjson?")

# If ENABLE_INTERNAL_FMT is ON, we force ENABLE_INTERNAL_SPDLOG ON as it has a hard
# dependency on fmt
if(ENABLE_INTERNAL_FMT)
  option(ENABLE_INTERNAL_SPDLOG "Enable internal spdlog Forced" ON)
else()
  dependent_option(ENABLE_INTERNAL_SPDLOG "Enable internal spdlog?")
endif()

dependent_option(ENABLE_INTERNAL_TAGLIB "Enable internal taglib?")

if(KODI_DEPENDSBUILD OR WIN32 OR WINDOWS_STORE)
  dependent_option(ENABLE_INTERNAL_TINYXML2 "Enable internal TinyXML2?")
endif()

# Internal Depends - supported on UNIX platforms
if(UNIX)
  option(FFMPEG_PATH        "Path to external ffmpeg?" "")
  option(ENABLE_INTERNAL_FSTRCMP "Enable internal fstrcmp?" OFF)
  option(ENABLE_INTERNAL_DAV1D "Enable internal dav1d?" OFF)
  option(ENABLE_INTERNAL_GTEST "Enable internal gtest?" OFF)
  option(ENABLE_INTERNAL_UDFREAD "Enable internal udfread?" OFF)
endif()
# prefer kissfft from xbmc/contrib but let use system one on unices
cmake_dependent_option(ENABLE_INTERNAL_KISSFFT "Enable internal kissfft?" ON "UNIX" ON)
# System options
if(NOT WIN32)
  option(WITH_ARCH              "build with given arch" OFF)
  option(WITH_CPU               "build with given cpu" OFF)
endif()
if(CORE_SYSTEM_NAME STREQUAL linux)
  option(ENABLE_EVENTCLIENTS    "Enable event clients support?" OFF)
  option(ADDONS_CONFIGURE_AT_STARTUP "Configure binary addons at startup?" ON)
endif()

# set scope of INTERNAL_DEPS
set_property(GLOBAL PROPERTY INTERNAL_DEPS_PROP)

# Build static libraries per directory
if(NOT CMAKE_GENERATOR MATCHES "Visual Studio" AND NOT CMAKE_GENERATOR STREQUAL Xcode)
  set(ENABLE_STATIC_LIBS TRUE)
else()
  set(ENABLE_STATIC_LIBS FALSE)
endif()

core_find_git_rev(APP_SCMID FULL)

set(AUDIO_BACKENDS_LIST "" CACHE STRING "Available audio backends")
set(GL_INTERFACES_LIST "" CACHE STRING "Available GL interfaces")

# Dynamically loaded libraries built with the project
add_custom_target(${APP_NAME_LC}-libraries)
set(LIBRARY_FILES "" CACHE STRING "" FORCE)
mark_as_advanced(LIBRARY_FILES)

set(INCLUDES ${CMAKE_SOURCE_DIR}
             ${CMAKE_SOURCE_DIR}/lib
             ${CMAKE_SOURCE_DIR}/xbmc
             ${CMAKE_SOURCE_DIR}/xbmc/${PLATFORM_DIR}
             ${CMAKE_SOURCE_DIR}/xbmc/cores/VideoPlayer
             ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}
             ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}/include)

if (NOT PLATFORMDEFS_DIR STREQUAL "")
  list(APPEND INCLUDES ${CMAKE_SOURCE_DIR}/xbmc/${PLATFORMDEFS_DIR})
endif()

find_package(PkgConfig)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED QUIET)
list(APPEND DEPLIBS ${CMAKE_THREAD_LIBS_INIT})

# Clean any existing generated build dir cmake files
file(REMOVE ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}/ExportFiles.cmake)
file(REMOVE ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}/GeneratedPackSkins.cmake)

foreach(depspec ${PLATFORM_REQUIRED_DEPS})
  # We need to specify ENABLE_${PLATFORM_REQUIRED_DEPS} in order for the
  # optional subdirectory for the specified platform to get built.
  split_dependency_specification(${depspec} dep version)
  string(TOUPPER ${dep} depup)
  if(NOT ${ENABLE_${depup}} STREQUAL AUTO AND NOT ${ENABLE_${depup}})
    message(WARNING "Your request to disable the dependency ${dep} required on platform ${CORE_PLATFORM_NAME} was ignored. Please choose another platform or add \"-DENABLE_${depup}=ON\" to your CMake command line to resolve this warning.")
  endif()
  set(ENABLE_${depup} "ON" CACHE BOOL "Force enabling required ${depup} support" FORCE)
endforeach()

# Required tools. Keep in alphabetical order please
set(required_buildtools FlatC
                        JsonSchemaBuilder
                        TexturePacker
)

# Optional build tools
set(optional_buildtools CCache
                        ClangFormat
                        ClangTidy
                        Cppcheck
                        IncludeWhatYouUse)

# Find build tools - Optional and required
core_optional_dep(${optional_buildtools})
core_require_dep(${required_buildtools})

# Required dependencies. Keep in alphabetical order please
set(required_deps ASS>=0.15.0
                  Cdio
                  CrossGUID
                  Curl
                  FFMPEG
                  FlatBuffers
                  Fmt
                  FreeType
                  FriBidi
                  Fstrcmp
                  HarfBuzz
                  Iconv
                  KissFFT
                  LibDvd
                  Lzo2
                  OpenSSL>=1.1.0
                  PCRE
                  RapidJSON>=1.0.2
                  Spdlog
                  Sqlite3
                  TagLib>=1.9.0
                  TinyXML
                  TinyXML2
                  ZLIB
                  ${PLATFORM_REQUIRED_DEPS})

# Optional dependencies. Keep in alphabetical order please
set(optional_deps Alsa
                  Avahi
                  Bluetooth
                  Bluray
                  CAP
                  CEC>=4.0.0
                  Dav1d
                  DBus
                  Iso9660pp
                  LCMS2
                  LircClient
                  MDNS
                  MicroHttpd
                  NFS
                  Pipewire>=0.3.50
                  Plist
                  PulseAudio
                  Python
                  SmbClient
                  Sndio
                  UDEV
                  Udfread
                  XSLT
                  ${PLATFORM_OPTIONAL_DEPS})

# Remove excluded platform specific optional_deps
foreach(excludedep ${PLATFORM_OPTIONAL_DEPS_EXCLUDE})
  list(FILTER optional_deps EXCLUDE REGEX ${excludedep})
endforeach()

# Check optional deps first, since their availability can influence required ones, e.g. ffmpeg
core_optional_dep(${optional_deps})
core_require_dep(${required_deps})

if(ENABLE_MARIADBCLIENT AND NOT ENABLE_MARIADBCLIENT STREQUAL AUTO AND ENABLE_MYSQLCLIENT AND NOT ENABLE_MYSQLCLIENT STREQUAL AUTO)
  MESSAGE(FATAL_ERROR "You can not use MySql and MariaDB at the same time. Disable one by adding -DENABLE_MYSQLCLIENT=OFF or -DENABLE_MARIADBCLIENT=OFF.")
elseif(ENABLE_MYSQLCLIENT AND NOT ENABLE_MYSQLCLIENT STREQUAL AUTO)
  set(ENABLE_MARIADBCLIENT OFF CACHE BOOL "")
endif()

core_optional_dep(MariaDBClient)
if(NOT TARGET MariaDBClient::MariaDBClient)
  core_optional_dep(MySqlClient)
endif()

if(NOT TARGET UDEV::UDEV)
  core_optional_dep(LibUSB)
endif()

if(ENABLE_UPNP)
  list(APPEND DEP_DEFINES "-DHAS_UPNP=1")
endif()

if(ENABLE_OPTICAL)
  list(APPEND DEP_DEFINES -DHAS_OPTICAL_DRIVE -DHAS_CDDA_RIPPER)
endif()

if(ENABLE_AIRTUNES)
  find_package(Shairplay)
  if(TARGET Shairplay::Shairplay)
    core_require_dep(Shairplay)
  endif()
endif()

# find all folders containing addon.xml.in
# used to define ADDON_XML_OUTPUTS, ADDON_XML_DEPENDS and ADDON_INSTALL_DATA
# Function defined in ./cmake/scripts/common/Macros.cmake
set(outputFilterRegex "addons/xbmc.json")
find_addon_xml_in_files(${outputFilterRegex})

if(TARGET ALSA::ALSA AND TARGET PulseAudio::PulseAudio)
  list(APPEND AUDIO_BACKENDS_LIST "alsa+pulseaudio")
endif()

# Compile Info
add_custom_command(OUTPUT ${CORE_BUILD_DIR}/xbmc/CompileInfo.cpp
                   COMMAND ${CMAKE_COMMAND} -DCORE_SOURCE_DIR=${CMAKE_SOURCE_DIR}
                                            -DCORE_SYSTEM_NAME=${CORE_SYSTEM_NAME}
                                            -DCORE_PLATFORM_NAME_LC="${CORE_PLATFORM_NAME_LC}"
                                            -DAUDIO_BACKENDS="${AUDIO_BACKENDS_LIST}"
                                            -DGL_INTERFACES="${GL_INTERFACES_LIST}"
                                            -DCORE_BUILD_DIR=${CORE_BUILD_DIR}
                                            -DCMAKE_BINARY_DIR=${CMAKE_BINARY_DIR}
                                            -DARCH_DEFINES="${ARCH_DEFINES}"
                                            -DAPP_SCMID=${APP_SCMID}
                                            -DAPP_COPYRIGHT_YEARS=${APP_COPYRIGHT_YEARS}
                                            -DAPP_BUILD_DATE=${APP_BUILD_DATE}
                                            -DAPP_SHARED_LIBRARY_SUFFIX="${APP_SHARED_LIBRARY_SUFFIX}"
                                            -DPYTHON_VERSION=${PYTHON_VERSION}

=== xbmc/addons/CMakeLists.txt ===
set(SOURCES Addon.cpp
            AddonBuilder.cpp
            BinaryAddonCache.cpp
            AddonDatabase.cpp
            AddonInstaller.cpp
            AddonManager.cpp
            AddonRepos.cpp
            AddonStatusHandler.cpp
            AddonSystemSettings.cpp
            AddonUpdateRules.cpp
            AddonVersion.cpp
            AudioDecoder.cpp
            ContextMenuAddon.cpp
            ContextMenus.cpp
            ExtsMimeSupportList.cpp
            FontResource.cpp
            FilesystemInstaller.cpp
            GameResource.cpp
            ImageDecoder.cpp
            ImageResource.cpp
            LanguageResource.cpp
            PluginSource.cpp
            Repository.cpp
            RepositoryUpdater.cpp
            Scraper.cpp
            ScreenSaver.cpp
            Service.cpp
            Skin.cpp
            UISoundsResource.cpp
            VFSEntry.cpp
            Visualization.cpp
            Webinterface.cpp)

set(HEADERS Addon.h
            AddonBuilder.h
            AddonEvents.h
            AddonRepoInfo.h
            BinaryAddonCache.h
            AddonDatabase.h
            AddonInstaller.h
            AddonManager.h
            AddonProvider.h
            AddonRepos.h
            AddonStatusHandler.h
            AddonSystemSettings.h
            AddonUpdateRules.h
            AddonVersion.h
            AudioDecoder.h
            ContextMenuAddon.h
            ContextMenus.h
            ExtsMimeSupportList.h
            FilesystemInstaller.h
            FontResource.h
            GameResource.h
            IAddon.h
            IAddonManagerCallback.h
            IAddonSupportCheck.h
            ImageDecoder.h
            ImageResource.h
            LanguageResource.h
            PluginSource.h
            Repository.h
            RepositoryUpdater.h
            Resource.h
            Scraper.h
            ScreenSaver.h
            Service.h
            Skin.h
            UISoundsResource.h
            VFSEntry.h
            Visualization.h
            Webinterface.h)

core_add_library(addons)

=== xbmc/dbwrappers/CMakeLists.txt ===
set(SOURCES Database.cpp
            DatabaseQuery.cpp
            dataset.cpp
            qry_dat.cpp
            sqlitedataset.cpp)

set(HEADERS Database.h
            DatabaseQuery.h
            dataset.h
            qry_dat.h
            sqlitedataset.h)

if(TARGET MySqlClient::MySqlClient OR TARGET MariaDBClient::MariaDBClient)
  list(APPEND SOURCES mysqldataset.cpp)
  list(APPEND HEADERS mysqldataset.h)
endif()

core_add_library(dbwrappers)

=== xbmc/favourites/CMakeLists.txt ===
set(SOURCES ContextMenus.cpp
            GUIViewStateFavourites.cpp
            GUIWindowFavourites.cpp
            FavouritesService.cpp
            FavouritesURL.cpp
            FavouritesUtils.cpp)

set(HEADERS ContextMenus.h
            GUIViewStateFavourites.h
            GUIWindowFavourites.h
            FavouritesService.h
            FavouritesURL.h
            FavouritesUtils.h)

core_add_library(favourites)

=== xbmc/filesystem/CMakeLists.txt ===
set(SOURCES AddonsDirectory.cpp
            AudioBookFileDirectory.cpp
            CacheStrategy.cpp
            CircularCache.cpp
            CurlFile.cpp
            DAVCommon.cpp
            DAVDirectory.cpp
            DAVFile.cpp
            DirectoryCache.cpp
            Directory.cpp
            DirectoryFactory.cpp
            DirectoryHistory.cpp
            DllLibCurl.cpp
            EventsDirectory.cpp
            FavouritesDirectory.cpp
            FileCache.cpp
            File.cpp
            FileDirectoryFactory.cpp
            FileFactory.cpp
            FTPDirectory.cpp
            FTPParse.cpp
            HTTPDirectory.cpp
            IDirectory.cpp
            IFile.cpp
            ImageFile.cpp
            LibraryDirectory.cpp
            MultiPathDirectory.cpp
            MultiPathFile.cpp
            MusicDatabaseDirectory.cpp
            MusicDatabaseFile.cpp
            MusicFileDirectory.cpp
            MusicSearchDirectory.cpp
            OverrideDirectory.cpp
            OverrideFile.cpp
            PipeFile.cpp
            PipesManager.cpp
            PlaylistDirectory.cpp
            PlaylistFileDirectory.cpp
            PluginDirectory.cpp
            PluginFile.cpp
            PVRDirectory.cpp
            ResourceDirectory.cpp
            ResourceFile.cpp
            RSSDirectory.cpp
            ShoutcastFile.cpp
            SmartPlaylistDirectory.cpp
            SourcesDirectory.cpp
            SpecialProtocol.cpp
            SpecialProtocolDirectory.cpp
            SpecialProtocolFile.cpp
            StackDirectory.cpp
            VideoDatabaseDirectory.cpp
            VideoDatabaseFile.cpp
            VirtualDirectory.cpp
            XbtDirectory.cpp
            XbtFile.cpp
            XbtManager.cpp
            ZeroconfDirectory.cpp
            ZipDirectory.cpp
            ZipFile.cpp
            ZipManager.cpp)

set(HEADERS AddonsDirectory.h
            CacheStrategy.h
            CircularCache.h
            CurlFile.h
            DAVCommon.h
            DAVDirectory.h
            DAVFile.h
            Directorization.h
            Directory.h
            DirectoryCache.h
            DirectoryFactory.h
            DirectoryHistory.h
            DllLibCurl.h
            EventsDirectory.h
            FTPDirectory.h
            FTPParse.h
            FavouritesDirectory.h
            File.h
            FileCache.h
            FileDirectoryFactory.h
            FileFactory.h
            HTTPDirectory.h
            IDirectory.h
            IFile.h
            IFileDirectory.h
            IFileTypes.h
            ImageFile.h
            LibraryDirectory.h
            MultiPathDirectory.h
            MultiPathFile.h
            MusicDatabaseDirectory.h
            MusicDatabaseFile.h
            MusicFileDirectory.h
            MusicSearchDirectory.h
            OverrideDirectory.h
            OverrideFile.h
            PVRDirectory.h
            PipeFile.h
            PipesManager.h
            PlaylistDirectory.h
            PlaylistFileDirectory.h
            PluginDirectory.h
            PluginFile.h
            RSSDirectory.h
            ResourceDirectory.h
            ResourceFile.h
            ShoutcastFile.h
            SmartPlaylistDirectory.h
            SourcesDirectory.h
            SpecialProtocol.h
            SpecialProtocolDirectory.h
            SpecialProtocolFile.h
            StackDirectory.h
            VideoDatabaseDirectory.h
            VideoDatabaseFile.h
            VirtualDirectory.h
            XbtDirectory.h
            XbtFile.h
            XbtManager.h
            ZeroconfDirectory.h
            ZipDirectory.h
            ZipFile.h
            ZipManager.h)

if(ISO9660PP_FOUND)
  list(APPEND SOURCES ISO9660Directory.cpp
                      ISO9660File.cpp)
  list(APPEND HEADERS ISO9660Directory.h
                      ISO9660File.h)
endif()

if(TARGET udfread::udfread)
  list(APPEND SOURCES UDFBlockInput.cpp
                      UDFDirectory.cpp
                      UDFFile.cpp)
  list(APPEND HEADERS UDFBlockInput.h
                      UDFDirectory.h
                      UDFFile.h)
endif()

if(BLURAY_FOUND)
  list(APPEND SOURCES BlurayCallback.cpp
                      BlurayDirectory.cpp
                      BlurayFile.cpp)
  list(APPEND HEADERS BlurayCallback.h
                      BlurayDirectory.h
                      BlurayFile.h)
endif()

if(ENABLE_OPTICAL)
  list(APPEND SOURCES CDDADirectory.cpp
                      CDDAFile.cpp
                      DVDDirectory.cpp)
  list(APPEND HEADERS CDDADirectory.h
                      CDDAFile.h
                      DVDDirectory.h)
endif()

if(TARGET libnfs::nfs)
  list(APPEND SOURCES NFSDirectory.cpp
                      NFSFile.cpp)
  list(APPEND HEADERS NFSDirectory.h
                      NFSFile.h)
endif()

if(ENABLE_UPNP)
  list(APPEND SOURCES NptXbmcFile.cpp
                      UPnPDirectory.cpp
                      UPnPFile.cpp)
  list(APPEND HEADERS UPnPDirectory.h
                      UPnPFile.h)
endif()

core_add_library(filesystem)
if(ENABLE_STATIC_LIBS AND ENABLE_UPNP)
  target_link_libraries(filesystem PRIVATE upnp)
endif()

=== xbmc/platform/CMakeLists.txt ===
set(SOURCES Environment.cpp
            xbmc.cpp)

set(HEADERS Environment.h
            Filesystem.h
            MessagePrinter.h
            Platform.h
            xbmc.h)

core_add_library(platform_common)

=== xbmc/storage/CMakeLists.txt ===
set(SOURCES AutorunMediaJob.cpp
            MediaManager.cpp)

set(HEADERS AutorunMediaJob.h
            IStorageProvider.h
            MediaManager.h)

if(ENABLE_OPTICAL)
  list(APPEND SOURCES cdioSupport.cpp
                      DetectDVDType.cpp)
  list(APPEND HEADERS cdioSupport.h
                      DetectDVDType.h
                      discs/IDiscDriveHandler.h)
endif()

core_add_library(storage)

=== xbmc/utils/CMakeLists.txt ===
set(SOURCES ActorProtocol.cpp
            AlarmClock.cpp
            AliasShortcutUtils.cpp
            Archive.cpp
            Base64.cpp
            BitstreamConverter.cpp
            BitstreamReader.cpp
            BitstreamStats.cpp
            BitstreamWriter.cpp
            BooleanLogic.cpp
            CharArrayParser.cpp
            CharsetConverter.cpp
            CharsetDetection.cpp
            ColorUtils.cpp
            ContentUtils.cpp
            CPUInfo.cpp
            Crc32.cpp
            CSSUtils.cpp
            DatabaseUtils.cpp
            Digest.cpp
            DiscsUtils.cpp
            EndianSwap.cpp
            EmbeddedArt.cpp
            ExecString.cpp
            FileExtensionProvider.cpp
            Fanart.cpp
            FileOperationJob.cpp
            FileUtils.cpp
            FontUtils.cpp
            GpuInfo.cpp
            GroupUtils.cpp
            HevcSei.cpp
            HTMLUtil.cpp
            HttpHeader.cpp
            HttpParser.cpp
            HttpRangeUtils.cpp
            HttpResponse.cpp
            InfoLoader.cpp
            JobManager.cpp
            JSONVariantParser.cpp
            JSONVariantWriter.cpp
            LabelFormatter.cpp
            LangCodeExpander.cpp
            LegacyPathTranslation.cpp
            Locale.cpp
            log.cpp
            Mime.cpp
            MovingSpeed.cpp
            Observer.cpp
            POUtils.cpp
            PlayerUtils.cpp
            RecentlyAddedJob.cpp
            RegExp.cpp
            rfft.cpp
            RingBuffer.cpp
            RssManager.cpp
            RssReader.cpp
            ProgressJob.cpp
            SaveFileStateJob.cpp
            ScraperParser.cpp
            ScraperUrl.cpp
            Screenshot.cpp
            SortUtils.cpp
            Speed.cpp
            StreamDetails.cpp
            StreamUtils.cpp
            StringUtils.cpp
            StringValidation.cpp
            SystemInfo.cpp
            Temperature.cpp
            TextSearch.cpp
            TimeUtils.cpp
            URIUtils.cpp
            UrlOptions.cpp
            Utf8Utils.cpp
            Variant.cpp
            VC1BitstreamParser.cpp
            Vector.cpp
            XBMCTinyXML.cpp
            XBMCTinyXML2.cpp
            XMLUtils.cpp)

set(HEADERS ActorProtocol.h
            AlarmClock.h
            AliasShortcutUtils.h
            Archive.h
            Base64.h
            BitstreamConverter.h
            BitstreamReader.h
            BitstreamStats.h
            BitstreamWriter.h
            BooleanLogic.h
            CharArrayParser.h
            CharsetConverter.h
            CharsetDetection.h
            CPUInfo.h
            ColorUtils.h
            ComponentContainer.h
            ContentUtils.h
            Crc32.h
            CSSUtils.h
            DatabaseUtils.h
            Digest.h
            DiscsUtils.h
            EndianSwap.h
            EventStream.h
            EventStreamDetail.h
            ExecString.h
            FileExtensionProvider.h
            Fanart.h
            FileOperationJob.h
            FileUtils.h
            FontUtils.h
            Geometry.h
            GlobalsHandling.h
            GpuInfo.h
            GroupUtils.h
            HDRCapabilities.h
            HevcSei.h
            HTMLUtil.h
            HttpHeader.h
            HttpParser.h
            HttpRangeUtils.h
            HttpResponse.h
            IArchivable.h
            IBufferObject.h
            ILocalizer.h
            InfoLoader.h
            IPlatformLog.h
            IRssObserver.h
            IScreenshotSurface.h
            ISerializable.h
            ISortable.h
            IXmlDeserializable.h
            Job.h
            JobManager.h
            JSONVariantParser.h
            JSONVariantWriter.h
            LabelFormatter.h
            LangCodeExpander.h
            LegacyPathTranslation.h
            Locale.h
            log.h
            logtypes.h
            Map.h
            MathUtils.h
            MemUtils.h
            Mime.h
            MovingSpeed.h
            Observer.h
            params_check_macros.h
            POUtils.h
            PlayerUtils.h
            ProgressJob.h
            RecentlyAddedJob.h
            RegExp.h
            rfft.h
            RingBuffer.h
            RssManager.h
            RssReader.h
            SaveFileStateJob.h
            ScopeGuard.h
            ScraperParser.h
            ScraperUrl.h
            Screenshot.h
            SortUtils.h
            Speed.h
            Stopwatch.h
            StreamDetails.h
            StreamUtils.h
            StringUtils.h
            StringValidation.h
            SystemInfo.h
            Temperature.h
            TextSearch.h
            TimeFormat.h
            TimeUtils.h
            TransformMatrix.h
            URIUtils.h
            UrlOptions.h
            Utf8Utils.h
            Variant.h
            VC1BitstreamParser.h
            Vector.h
            XBMCTinyXML.h
            XBMCTinyXML2.h
            XMLUtils.h
            XTimeUtils.h)

if(TARGET XSLT::XSLT)
  list(APPEND SOURCES XSLTUtils.cpp)
  list(APPEND HEADERS XSLTUtils.h)
endif()
if(TARGET EGL::EGL)
  list(APPEND SOURCES EGLUtils.cpp
                      EGLFence.cpp)
  list(APPEND HEADERS EGLUtils.h
                      EGLFence.h)
endif()

# The large map trips the clang optimizer
if(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
  set_source_files_properties(Mime.cpp PROPERTIES COMPILE_FLAGS -O0)
endif()

if(TARGET OpenGL::GL OR TARGET OpenGL::GLES)
  list(APPEND SOURCES GLUtils.cpp)
  list(APPEND HEADERS GLUtils.h)
endif()

if("gbm" IN_LIST CORE_PLATFORM_NAME_LC OR "wayland" IN_LIST CORE_PLATFORM_NAME_LC)
  list(APPEND SOURCES BufferObject.cpp
                      BufferObjectFactory.cpp)
  list(APPEND HEADERS BufferObject.h
                      BufferObjectFactory.h)

  if("gbm" IN_LIST CORE_PLATFORM_NAME_LC)
    list(APPEND SOURCES DumbBufferObject.cpp)
    list(APPEND SOURCES DumbBufferObject.h)
  endif()

  if(HAVE_LINUX_MEMFD AND HAVE_LINUX_UDMABUF)
    list(APPEND SOURCES UDMABufferObject.cpp)
    list(APPEND HEADERS UDMABufferObject.h)
  endif()

  if(HAVE_LINUX_DMA_HEAP)
    list(APPEND SOURCES DMAHeapBufferObject.cpp)
    list(APPEND HEADERS DMAHeapBufferObject.h)
  endif()

  if(GBM_HAS_BO_MAP AND "gbm" IN_LIST CORE_PLATFORM_NAME_LC)
    list(APPEND SOURCES GBMBufferObject.cpp)
    list(APPEND HEADERS GBMBufferObject.h)
  endif()

  if(TARGET EGL::EGL)
    list(APPEND SOURCES EGLImage.cpp)
    list(APPEND HEADERS EGLImage.h)
  endif()

  if(TARGET LIBDRM::LIBDRM)
    list(APPEND SOURCES DRMHelpers.cpp)
    list(APPEND HEADERS DRMHelpers.h)
  endif()

  if(LIBDISPLAYINFO_FOUND)
    list(APPEND SOURCES DisplayInfo.cpp)
    list(APPEND HEADERS DisplayInfo.h)
  endif()
endif()

core_add_library(utils)

if(NOT CORE_SYSTEM_NAME STREQUAL windows AND NOT CORE_SYSTEM_NAME STREQUAL windowsstore)
  if(HAVE_SSE2)
    target_compile_options(${CORE_LIBRARY} PRIVATE -msse2)
  endif()
endif()

=== xbmc/weather/CMakeLists.txt ===
set(SOURCES GUIWindowWeather.cpp
            WeatherJob.cpp
            WeatherManager.cpp)

set(HEADERS GUIWindowWeather.h
            WeatherJob.h
            WeatherManager.h)

core_add_library(weather)

=== xbmc/filesystem/test/CMakeLists.txt ===
set(SOURCES TestDirectory.cpp
            TestFile.cpp
            TestFileFactory.cpp
            TestZipFile.cpp
            TestZipManager.cpp)

if(MICROHTTPD_FOUND)
  list(APPEND SOURCES TestHTTPDirectory.cpp)
endif()

if(TARGET libnfs::nfs)
  list(APPEND SOURCES TestNfsFile.cpp)
endif()

core_add_test_library(filesystem_test)

=== xbmc/interfaces/swig/CMakeLists.txt ===
function(generate_file file)
  set(classpath ${groovy_SOURCE_DIR}/lib/*
                ${apache-commons-lang_SOURCE_DIR}/*
                ${apache-commons-text_SOURCE_DIR}/*
                ${CMAKE_SOURCE_DIR}/tools/codegenerator
                ${CMAKE_CURRENT_SOURCE_DIR}/../python)
  if(NOT CORE_SYSTEM_NAME STREQUAL windows AND NOT CORE_SYSTEM_NAME STREQUAL windowsstore)
    set(devnull "/dev/null")
    string(REPLACE ";" ":" classpath "${classpath}")
  else()
    set(devnull "nul")
  endif()

  set(CPP_FILE ${file}.cpp)
  if(CLANGFORMAT_FOUND)
    set(CLANG_FORMAT_COMMAND COMMAND ${CLANG_FORMAT_EXECUTABLE} ARGS -i ${CPP_FILE})
  endif()

  if(Java_VERSION_MAJOR GREATER 8)
    set(JAVA_OPEN_OPTS --add-opens java.base/java.util=ALL-UNNAMED --add-opens java.base/java.util.regex=ALL-UNNAMED --add-opens java.base/java.io=ALL-UNNAMED --add-opens java.base/java.lang=ALL-UNNAMED  --add-opens java.base/java.net=ALL-UNNAMED)
  endif()

  add_custom_command(OUTPUT ${CPP_FILE}
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS -w401 -c++ -o ${file}.xml -xml -I${CMAKE_SOURCE_DIR}/xbmc ${CMAKE_CURRENT_SOURCE_DIR}/../swig/${file}
                     COMMAND ${Java_JAVA_EXECUTABLE}
                     ARGS ${JAVA_OPEN_OPTS} -cp "${classpath}" groovy.ui.GroovyMain ${CMAKE_SOURCE_DIR}/tools/codegenerator/Generator.groovy ${file}.xml ${CMAKE_CURRENT_SOURCE_DIR}/../python/PythonSwig.cpp.template ${file}.cpp > ${devnull}
                     ${CLANG_FORMAT_COMMAND}
                     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../swig/${file} ${CMAKE_CURRENT_SOURCE_DIR}/../python/PythonSwig.cpp.template)
  set(SOURCES ${SOURCES} "${CPP_FILE}" PARENT_SCOPE)
endfunction()

find_package(Java COMPONENTS Runtime REQUIRED)
find_package(SWIG REQUIRED)

# Default URL/Versions/Hashes to use unless *_SOURCE_DIR are set for the relevant binary
set(GROOVY_VER 4.0.16)
set(GROOVY_URL ${KODI_MIRROR}/build-deps/sources/apache-groovy-binary-${GROOVY_VER}.zip)
set(GROOVY_URL_HASH URL_HASH SHA512=743698979c801f3cfb36545888b5303e1e25dae5692bb45cab7ebbe102a6eda31f09abc6978349ad90ecaf630416fc87eacba7781244855e7e771a3c44041fa0)

set(APACHE_COMMONS_LANG_VER 3.14.0)
set(APACHE_COMMONS_LANG_URL ${KODI_MIRROR}/build-deps/sources/commons-lang3-${APACHE_COMMONS_LANG_VER}-bin.tar.gz)
set(APACHE_COMMONS_LANG_URL_HASH URL_HASH SHA512=8e7e62418a49ba810512c13a640a8bf35f878fcd54af32fdaab1111e37817f58b21b475980ba663fba4887e45ef8d88af8ff17796f20d202e929e8e2574546dc)

set(APACHE_COMMONS_TEXT_VER 1.11.0)
set(APACHE_COMMONS_TEXT_URL ${KODI_MIRROR}/build-deps/sources/commons-text-${APACHE_COMMONS_TEXT_VER}-bin.tar.gz)
set(APACHE_COMMONS_TEXT_URL_HASH URL_HASH SHA512=2e94877000dd270b69e2e8cbf49f258a90b4c628b6b6b0814e300a2f0e9c391f0816dceb0707e596ae3b7c9532f93e7a4917df47c77f44b3a810e14042ce5f3f)

include(FetchContent)
FetchContent_Declare(
  groovy
  URL ${GROOVY_URL}
  ${GROOVY_URL_HASH}
  DOWNLOAD_DIR ${TARBALL_DIR}
  SOURCE_DIR ${DEPENDS_PATH}/share/groovy
)

FetchContent_Declare(
  apache-commons-lang
  URL ${APACHE_COMMONS_LANG_URL}
  ${APACHE_COMMONS_LANG_URL_HASH}
  DOWNLOAD_DIR ${TARBALL_DIR}
  SOURCE_DIR ${DEPENDS_PATH}/share/java/lang
)

FetchContent_Declare(
  apache-commons-text
  URL ${APACHE_COMMONS_TEXT_URL}
  ${APACHE_COMMONS_TEXT_URL_HASH}
  DOWNLOAD_DIR ${TARBALL_DIR}
  SOURCE_DIR ${DEPENDS_PATH}/share/java/text
)

if(NOT groovy_SOURCE_DIR)
  if(NOT EXISTS ${DEPENDS_PATH}/share/groovy/lib/groovy-${GROOVY_VER}.jar OR
     NOT EXISTS ${DEPENDS_PATH}/share/groovy/lib/groovy-xml-${GROOVY_VER}.jar OR
     NOT EXISTS ${DEPENDS_PATH}/share/groovy/lib/groovy-templates-${GROOVY_VER}.jar)
    FetchContent_MakeAvailable(groovy)
  else()
    set(groovy_SOURCE_DIR ${DEPENDS_PATH}/share/groovy)
  endif()
endif()

if(NOT apache-commons-lang_SOURCE_DIR)
  if(NOT EXISTS ${DEPENDS_PATH}/share/java/lang/commons-lang3-${APACHE_COMMONS_LANG_VER}.jar)
    FetchContent_MakeAvailable(apache-commons-lang)
  else()
    set(apache-commons-lang_SOURCE_DIR ${DEPENDS_PATH}/share/java/lang)
  endif()
endif()

if(NOT apache-commons-text_SOURCE_DIR)
  if(NOT EXISTS ${DEPENDS_PATH}/share/java/text/commons-text-${APACHE_COMMONS_TEXT_VER}.jar)
    FetchContent_MakeAvailable(apache-commons-text)
  else()
    set(apache-commons-text_SOURCE_DIR ${DEPENDS_PATH}/share/java/text)
  endif()
endif()

# The generated bindings
set(INPUTS AddonModuleXbmcaddon.i
           AddonModuleXbmcdrm.i
           AddonModuleXbmcgui.i
           AddonModuleXbmc.i
           AddonModuleXbmcplugin.i
           AddonModuleXbmcvfs.i
           AddonModuleXbmcwsgi.i)

set(GROOVY_DIR ${CMAKE_SOURCE_DIR}/tools/codegenerator/groovy)

foreach(INPUT IN LISTS INPUTS)
  generate_file(${INPUT})
  list(APPEND GEN_SRCS ${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp)
endforeach()

add_library(python_binding STATIC ${SOURCES})
set_target_properties(python_binding PROPERTIES POSITION_INDEPENDENT_CODE TRUE
                                                FOLDER "Build Utilities")
set(core_DEPENDS python_binding ${core_DEPENDS} CACHE STRING "" FORCE)
add_dependencies(python_binding ${GLOBAL_TARGET_DEPS})
# This propagates target options from dependencies (eg spdlog definitions)
target_link_libraries(python_binding PRIVATE ${GLOBAL_TARGET_DEPS})

if(CORE_SYSTEM_NAME STREQUAL windowsstore)
  set_target_properties(python_binding PROPERTIES STATIC_LIBRARY_FLAGS "/ignore:4264")
endif()
if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
  set_target_properties(python_binding PROPERTIES
                        COMPILE_FLAGS -Wno-cast-function-type) # from -Wextra
endif()

=== xbmc/media/drm/CMakeLists.txt ===
set(SOURCES CryptoSession.cpp)

set(HEADERS CryptoSession.h)

core_add_library(drm)

=== debian/changelog ===
kodi (2:21.2+dfsg-4pureos1) dawn; urgency=medium

  * Sync with Debian trixie
  * Remaining PureOS changes:
    - suppress building official repository package;
      PureOS: #209

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 20 Oct 2025 08:56:08 +0200

kodi (2:20.1+dfsg-1pureos1) crimson; urgency=medium

  * Sync with Debian bookworm
  * Remaining PureOS changes:
    - suppress building official repository package;
      PureOS: #209

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Thu, 22 Jun 2023 11:20:50 +0200

kodi (2:19.1+dfsg2-2+deb11u1pureos1) byzantium; urgency=medium

  * Merge with Debian Bullseye, remaining change:
    - suppress building official repository package;
      PureOS: #209

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Wed, 07 Jun 2023 04:17:50 +0200

kodi (2:19.1+dfsg2-2+deb11u1) bullseye; urgency=medium

  * Branch out bullseye
  * Fix buffer overflow in PLS playlists (Closes: CVE-2021-42917)

 -- Vasyl Gello <vasek.gello@gmail.com>  Thu, 04 Nov 2021 09:17:25 +0000

kodi (2:19.0+dfsg1-1pureos1) byzantium; urgency=medium

  * fork for PureOS:
    + set PureOS Maintainers as maintainer,
      leaving original as XSBC-Original-Maintainer
    + drop uploaders (unused by PureOS Maintainers)
    + replace Vcs-* fields
    + add git-buildpackage setting debian-branch
  * suppress building official repository package;
    PureOS: #209

 -- Jonas Smedegaard <jonas.smedegaard@puri.sm>  Sat, 27 Mar 2021 13:26:29 +0100

=== debian/control ===
Source: kodi
Priority: optional
Section: video
Maintainer: PureOS Maintainers <pureos-project@lists.puri.sm>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Vasyl Gello <vasek.gello@gmail.com>
Build-Depends: cmake,
               curl,
               debhelper-compat (= 13),
               default-jre:native,
               default-libmysqlclient-dev,
               dh-python,
               doxygen,
               fontforge-nox,
               fonts-dejavu-core,
               fonts-droid-fallback,
               gawk,
               gettext,
               gperf,
               groovy:native,
               libhowardhinnant-date-dev,
               libasound2-dev | libasound-dev,
               libass-dev,
               libavahi-client-dev,
               libavahi-common-dev,
               libavcodec-dev (>= 7:4.2.2),
               libavfilter-dev (>= 7:4.2.2),
               libavformat-dev (>= 7:4.2.2),
               libavutil-dev (>= 7:4.2.2),
               libbluetooth-dev,
               libbluray-dev (>= 1:0.7.0),
               libcap-dev,
               libcdio-dev,
               libcec-dev (>= 4~),
               libcommons-lang-java:native,
               libcrossguid-dev,
               libcurl4-gnutls-dev | libcurl-dev,
               libcwiid-dev [linux-any],
               libdav1d-dev (>= 0.7.0),
               libdbus-1-dev,
               libdisplay-info-dev,
               libdrm-dev,
#               libdvdnav-dev, use patched embedded version
#               libdvdread-dev, use patched embedded version
               libegl1-mesa-dev,
               libflatbuffers-dev,
               libfmt-dev (>= 6.1.2),
               libfontconfig-dev,
               libfreetype-dev,
               libfribidi-dev,
               libfstrcmp-dev,
               libgbm-dev,
               libgcrypt-dev,
               libgif-dev,
               libgif-dev:native,
               libgl-dev,
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libgnutls28-dev,
               libgpg-error-dev,
               libgtest-dev (>= 1.10.0~),
               libinput-dev,
               libiso9660-dev,
               libiso9660++-dev,
               libjpeg-dev,
               libjpeg-dev:native,
               libkissfft-dev (>= 131.1.0~),
               liblcms2-dev,
               liblirc-dev,
               libltdl-dev,
               liblzo2-dev,
               liblzo2-dev:native,
               libmicrohttpd-dev,
               libnfs-dev,
               libpcre2-dev,
               libpipewire-0.3-dev,
               libplist-dev,
               libpng-dev,
               libpng-dev:native,
               libpostproc-dev (>= 7:4.2.2),
               libpulse-dev,
               libpython3-dev,
               librsvg2-bin,
               libshairplay-dev (>= 0.9.0~),
               libsmbclient-dev,
               libsndio-dev,
               libspdlog-dev (>= 1:1.5.0),
               libsqlite3-dev,
               libswresample-dev (>= 7:4.2.2),
               libswscale-dev (>= 7:4.2.2),
               libtag-dev (>= 1.8),
               libtinyxml-dev,
               libtinyxml2-dev,
               libtool,
               libudev-dev,
               libudfread-dev (>= 1.0.0),
               libva-dev,
               libvdpau-dev,
               libxkbcommon-dev,
               libxrandr-dev,
               libxslt1-dev,
               libxt-dev,
               nasm [i386],
               python3-dev:any,
               python3-setuptools,
               rapidjson-dev,
               swig,
               unzip,
               uuid-dev,
               valgrind [amd64 i386],
               wayland-protocols,
               waylandpp-dev,
               zip,
               zlib1g-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://kodi.tv/
Vcs-Git: https://source.puri.sm/pureos/packages/kodi.git
Vcs-Browser: https://source.puri.sm/pureos/packages/kodi
XSBC-Original-Vcs-Browser: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi
XSBC-Original-Vcs-Git: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi.git -b debian/sid

Package: kodi
Architecture: any
Depends: kodi-bin (>= ${source:Version}),
         kodi-bin (<< ${source:Version}.1~),
         kodi-data (>= ${source:Version}),
         ${misc:Depends}
Recommends: kodi-repository-kodi | kodi-repository,
            kodi-visualization-spectrum
Breaks: xbmc (<< 2:13.2+dfsg1-5~), ${kodi:APIBREAKS}
Provides: ${kodi:APIPROVIDES}
Replaces: xbmc (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (executable binaries)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains the kodi binaries.

Package: kodi-data
Architecture: all
Multi-Arch: foreign
Depends: mesa-utils,
         x11-utils,
         libjs-jquery,
         libjs-iscroll,
         ${misc:Depends}
Recommends: fonts-noto-core,
            fonts-noto-mono,
            fonts-roboto-unhinted,
Suggests: fonts-noto-ui-core,
Breaks: xbmc (<< 2:13.2+dfsg1-5~)
Replaces: xbmc (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (arch-independent data package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains all the architecture independent data needed to have a
 working Kodi.

Package: kodi-bin
Architecture: any
Depends: python3-pil,
         python3-pycryptodome,
         ${python3:Depends},
         ${dlopenlibs:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Recommends: ${shlibs:Recommends},
            udisks2
Pre-Depends: ${misc:Pre-Depends}
Breaks: xbmc-bin (<< 2:13.2+dfsg1-5~)
Conflicts: libgl1-mesa-swx11
Replaces: xbmc-bin (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (architecture-dependent files)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains the binaries needed to have a working Kodi.

Package: kodi-eventclients-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Open Source Home Theatre (Event Client Common package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package is the common package for Kodi Event Client.

Package: kodi-eventclients-python
Architecture: any
Depends: kodi-eventclients-common (= ${source:Version}),
         python3-bluez,
         ${python3:Depends},
         ${misc:Depends}
Breaks: kodi-eventclients-common (<< 2:19.4+dfsg1-1~)
Replaces: kodi-eventclients-common (<< 2:19.4+dfsg1-1~)
Description: Open Source Home Theatre (Event Client Python package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package is the virtual Python package for Kodi Event Client.

Package: kodi-eventclients-dev-common
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Breaks: kodi-eventclients-dev (<< 2:19.4+dfsg1-1~)
Replaces: kodi-eventclients-dev (<< 2:19.4+dfsg1-1~)

=== debian/rules ===
#!/usr/bin/make -f

# avoid repository package. Fixes https://tracker.pureos.net/T209
export DH_OPTIONS = --no-package=kodi-repository-kodi

# Avoid custom build rule silencing
export V=1

# Include /usr/share/dpkg/pkg-info.mk to get DEB_{SOURCE,VERSION}
include /usr/share/dpkg/pkg-info.mk

# Include /usr/share/dpkg/architecture.mk to get DEB_HOST_{MULTI,}ARCH
include /usr/share/dpkg/architecture.mk

# bindnow breaks wrappers used in with libdvdread
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-bindnow

DVDNAV_COMPONENT = libdvdnav-embedded
DVDNAV_URL = tools/depends/target/libdvdnav/libdvdnav-embedded.tar.xz
DVDREAD_COMPONENT = libdvdread-embedded
DVDREAD_URL = tools/depends/target/libdvdread/libdvdread-embedded.tar.xz

export DEB_CFLAGS_MAINT_STRIP  = -O2
export DEB_CFLAGS_MAINT_APPEND  = -O3
export DEB_CXXFLAGS_MAINT_STRIP  = -O2
export DEB_CXXFLAGS_MAINT_APPEND  = -O3

BUILD_WAYLAND := yes
BUILD_GBM := yes

NUMCPU =
# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NUMCPU := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

# Various environment variables to set
export DEB_LDFLAGS_MAINT_APPEND = -latomic -lpthread
# for embedded libdvd* and Kodi from Debian patch:
export DEB_CPPFLAGS_MAINT_APPEND = -D_XBMC -DDEB_VERSION=\"$(DEB_VERSION)\"

KODI_PLATFORMS := x11

ifeq ($(BUILD_WAYLAND),yes)
	KODI_PLATFORMS := $(KODI_PLATFORMS) wayland
endif
ifeq ($(BUILD_GBM),yes)
	KODI_PLATFORMS := $(KODI_PLATFORMS) gbm
endif

# basilgello: keep these overrides to ensure CMake honors
# the 32-bit architecture requested by 'dpkg-buildpackage'
# (like 'i486-linux') on 64-bit machines (like 'amd64').
ifneq (,$(filter alpha,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=alpha
else ifneq (,$(filter amd64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=x86_64-linux
else ifneq (,$(filter arm64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=aarch64
else ifneq (,$(filter armel armhf,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=arm
else ifneq (,$(filter i386,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=i486-linux
else ifneq (,$(filter m68k,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=m68k
else ifneq (,$(filter mipsel,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips
else ifneq (,$(filter mips64el,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips64
else ifneq (,$(filter powerpc,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=ppc
else ifneq (,$(filter ppc64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=ppc64
else ifneq (,$(filter ppc64el,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=ppc64
else ifneq (,$(filter riscv64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=riscv64
else ifneq (,$(filter s390x,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=s390x
# TODO: Workaround for #1043076 - remove when resolved
export DEB_CFLAGS_MAINT_APPEND  = -O3 -fexcess-precision=fast
export DEB_CXXFLAGS_MAINT_APPEND  = -O3 -fexcess-precision=fast
else ifneq (,$(filter sh4,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=sh4
else ifneq (,$(filter sparc64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=sparc64
endif

# Build arm* architectures with GLES instead of GL
# (Closes: 1056563)
ifneq (,$(filter armel armhf arm64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DAPP_RENDER_SYSTEM=gles
else
EXTRA_FLAGS := $(EXTRA_FLAGS) -DAPP_RENDER_SYSTEM=gl
endif

# basilgello: If cross-compiling, tell Kodi to look for native prerequisites
# in $(CURDIR)/native-tools, where the override_dh_autoconfigure step builds
# them for the build architecture (the native architecture of builder machine)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
EXTRA_FLAGS := $(EXTRA_FLAGS) \
	-DWITH_JSONSCHEMABUILDER=$(CURDIR)/native-tools/bin/JsonSchemaBuilder \
	-DWITH_TEXTUREPACKER=$(CURDIR)/native-tools/bin/TexturePacker
endif

# Kodi configuration options
#
KODI_OPTS=\
-DVERBOSE=1 \
-DUSE_LTO=$(NUMCPU) \
-DCMAKE_BUILD_TYPE=RelWithDebInfo \
-DENABLE_AIRTUNES=ON \
-DENABLE_ALSA=ON \
-DENABLE_AVAHI=ON \
-DENABLE_BLURAY=ON \
-DENABLE_CEC=ON \
-DENABLE_DBUS=ON \
-DENABLE_DEBUGFISSION=OFF \
-DENABLE_DVDCSS=OFF \
-DENABLE_EVENTCLIENTS=ON \
-DENABLE_INTERNAL_CROSSGUID=OFF \
-DENABLE_INTERNAL_DATE=OFF \
-DENABLE_INTERNAL_FFMPEG=OFF \
-DENABLE_INTERNAL_KISSFFT=OFF \
-DENABLE_INTERNAL_LIBDVD=ON \
-DENABLE_INTERNAL_RapidJSON=OFF \
-DENABLE_INTERNAL_TZDATA=OFF \
-DENABLE_MICROHTTPD=ON \
-DENABLE_MYSQLCLIENT=ON \
-DENABLE_NFS=ON \
-DENABLE_OPTICAL=ON \
-DENABLE_PULSEAUDIO=ON \
-DENABLE_SMBCLIENT=ON \
-DENABLE_UDEV=ON \
-DENABLE_UPNP=ON \
-DENABLE_VAAPI=ON \
-DENABLE_VDPAU=ON \
-DENABLE_XSLT=ON \
-DLIBDVDREAD_URL=$(DVDREAD_URL) \
-DLIBDVDNAV_URL=$(DVDNAV_URL) \
-DENABLE_LIRCCLIENT=ON \
-DNEON=False \
-DCORE_PLATFORM_NAME="$(KODI_PLATFORMS)" \
$(EXTRA_FLAGS)

%:
	dh $@ --buildsystem cmake --with python3

override_dh_clean:
	# Restore official addon repository list in version.txt
	sed -i \
		'/^ADDON_REPOS/s+,repository.debian.languages|file:///usr/share/kodi/language-repo++' \
		version.txt
	# Clean up "repository.debian.languages" addon
	echo "Cleaning up repository.debian.languages ..."
	rm -rf $(CURDIR)/addons/repository.debian.languages \
		$(CURDIR)/repo-resources-embedded/language-repo
	sed -i "/<addon optional=\"true\">repository.debian.languages</d" \
		$(CURDIR)/system/addon-manifest.xml
	sed -i "/repository.debian.languages\//d" \
		$(CURDIR)/cmake/installdata/common/addons.txt
	# Perform the rest of cleaning
	dh_clean \
		addons/skin.estuary/media/from-debian-logo.png \
		addons/webinterface.default/ \
		debian/dh-addon/*.1 \
		lib/gtest/ \
		media/Fonts/arial.ttf \
		native-tools/ \
		$(DVDNAV_URL) \
		$(DVDREAD_URL)

# fall back to old location of DejaVuSans.ttf if needed
ifneq ("$(wildcard /usr/share/fonts/truetype/dejavu/DejaVuSans.ttf)","")
DEJAVUSANS=/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf
else
DEJAVUSANS=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf
endif

media/Fonts/arial.ttf: debian/mergefonts.ff
	# work around #948876 until fontforge is fixed by using cached result
	fontforge -script $< \
		/usr/share/fonts/truetype/droid/DroidSansFallbackFull.ttf \
		$(DEJAVUSANS) \
		$@ || cp debian/extra/arial.ttf $@

lib/gtest/lib/.libs/libgtest.a:
	cp -r /usr/src/gtest/ $(CURDIR)/lib/ && mkdir -p $(CURDIR)/lib/gtest/lib/.libs

addons/skin.estuary/media/from-debian-logo.png: debian/from-debian-logo.svg
	rsvg-convert -w 250 -h 82 -o $@ $<

embedded-libs:
	# Copy default webinterface addon
	cp -r $(CURDIR)/debian/webinterface-default $(CURDIR)/addons/webinterface.default
	# Add repository.debian.languages as official addon repository list in version.txt
	sed -i \
		'/^ADDON_REPOS/s+^.*$$+&,repository.debian.languages|file:///usr/share/kodi/language-repo+' \
		version.txt
	# Add repository.debian.languages addon
	echo "Adding repository.debian.languages ..."
	cp -r $(CURDIR)/debian/language-repo $(CURDIR)/addons/repository.debian.languages
	sed -i "/<\/addons>/i\ \ <addon optional=\"true\">repository.debian.languages<\/addon>" \
		$(CURDIR)/system/addon-manifest.xml
	echo "addons/repository.debian.languages/*" \
		1>>$(CURDIR)/cmake/installdata/common/addons.txt
	# Build repository.debian.languages repository
	cd repo-resources-embedded && \
		python3 ../debian/generate-repo.py language-repo
	# Prepare archives from embedded libdvd*
	tar -cf $(DVDNAV_URL) $(DVDNAV_COMPONENT)
	tar -cf $(DVDREAD_URL) $(DVDREAD_COMPONENT)

override_dh_auto_configure: addons/skin.estuary/media/from-debian-logo.png embedded-libs lib/gtest/lib/.libs/libgtest.a media/Fonts/arial.ttf
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	# We are cross-compiling!
	# Produce the JsonSchemaBuilder and TexturePacker
	# prerequisites for the build architecture
